from Screens.Screen import Screen
from Plugins.Plugin import PluginDescriptor
from Components.ActionMap import ActionMap
from Components.MenuList import MenuList
import xml.dom.minidom
import os
from Screens.MessageBox import MessageBox


class SelectCountry(Screen):
	skin = """
		<screen position="90,95" size="560,430" title="NTP Update Manager" >
			  <widget name="countrymenu" position="10,0" size="550,420" scrollbarMode="showOnDemand" />
		</screen>
		"""

	def __init__(self, session, xmlparse, selection):
		self.skin = SelectCountry.skin
		Screen.__init__(self,session)

		self.xmlparse = xmlparse
		self.selection = selection
    
		list = []
		for contenant in self.xmlparse.getElementsByTagName("contenant"):
			if str(contenant.getAttribute("cont").encode("utf8")) == self.selection:
				for country in contenant.getElementsByTagName("country"):
					list.append(country.getAttribute("name").encode("utf8"))

		self["countrymenu"] = MenuList(list)
		self["actions"] = ActionMap(["SetupActions"],
		{
			"ok"  		:	self.selCountry,
			"cancel"  :	self.close,
		}, -2)

	def selCountry(self):
		if os.path.isfile("/etc/init.d/ntpupdate.sh"):
			selection_country = self["countrymenu"].getCurrent()
			for contenant in self.xmlparse.getElementsByTagName("contenant"):
				if str(contenant.getAttribute("cont").encode("utf8")) == self.selection:
					for country in contenant.getElementsByTagName("country"):
						if country.getAttribute("name").encode("utf8") == selection_country:
							ntpServer = str(country.getElementsByTagName("ntp")[0].childNodes[0].data)
      
			print "ntp server name is: ", ntpServer
			cmd = "echo " + ntpServer + " >/etc/ntpserver"
			os.system(cmd)
			cmd = '/etc/init.d/ntpupdate.sh start'
			os.system(cmd)
			message = "NTP server " + ntpServer + " is activated" 
			mybox = self.session.openWithCallback(self.close, MessageBox, message, MessageBox.TYPE_INFO, timeout=5)
			mybox.setTitle(_("Ntp Update Manager"))
      

class NTPManager(Screen):
	skin = """
		<screen position="90,95" size="560,430" title="NTP Update Manager" >
			  <widget name="menu" position="10,0" size="550,420" scrollbarMode="showOnDemand" />
		</screen>
		"""

	def __init__(self, session):
		self.skin = NTPManager.skin
		Screen.__init__(self,session)
    
		list = []
		xmlfile = "/usr/lib/enigma2/python/Plugins/Extensions/NTPUpdateManager/ntpurls.xml"
		if os.path.isfile(xmlfile):
			xmlparse = xml.dom.minidom.parse(xmlfile)
			for contenant in xmlparse.getElementsByTagName("contenant"):
				list.append(contenant.getAttribute("cont").encode("utf8"))
			self.xmlparse = xmlparse

			self["menu"] = MenuList(list)
			self["actions"] = ActionMap(["SetupActions"],
			{
				"ok"  		:	self.selContenant,
				"cancel"  :	self.close,
			}, -2)
		else:
			self.close

	def selContenant(self):
		selection = str(self["menu"].getCurrent())
		self.session.openWithCallback(self.close, SelectCountry, self.xmlparse, selection)

def main(session, **kwargs):
	session.open(NTPManager)

def Plugins(**kwargs):
	return PluginDescriptor(
		name="NTP Update Manager",
		description=_("Select the NTP server and start NTPupdate"),
		where = [ PluginDescriptor.WHERE_EXTENSIONSMENU, PluginDescriptor.WHERE_PLUGINMENU ],
		icon = "plugin.png", fnc = main)